diff --git a/libyara/modules/dotnet/dotnet.c b/libyara/modules/dotnet/dotnet.c
index cdf1f4b39..e467f6fda 100644
--- a/libyara/modules/dotnet/dotnet.c
+++ b/libyara/modules/dotnet/dotnet.c
@@ -92,11 +92,15 @@ void dotnet_parse_guid(
   char guid[37];
   int i = 0;
 
-  const uint8_t* guid_offset = pe->data + metadata_root + yr_le32toh(guid_header->Offset);
+  const uint8_t* guid_offset = pe->data + \
+      metadata_root + yr_le32toh(guid_header->Offset);
+
   DWORD guid_size = yr_le32toh(guid_header->Size);
 
-  // Parse GUIDs if we have them.
-  // GUIDs are 16 bytes each.
+  // Limit the number of GUIDs to 16.
+  guid_size =  yr_min(guid_size, 256);
+
+  // Parse GUIDs if we have them. GUIDs are 16 bytes each.
   while (guid_size >= 16 && fits_in_pe(pe, guid_offset, 16))
   {
     sprintf(guid, "%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x",
@@ -118,6 +122,7 @@ void dotnet_parse_guid(
 
     i++;
     guid_size -= 16;
+    guid_offset += 16;
   }
 
   set_integer(i, pe->object, "number_of_guids");
@@ -1363,7 +1368,7 @@ void dotnet_parse_tilde_2(
 
       case BIT_METHODSPEC:
         row_count = max_rows(2,
-            yr_le32toh(rows.methoddef), 
+            yr_le32toh(rows.methoddef),
             yr_le32toh(rows.memberref));
 
         if (row_count > (0xFFFF >> 0x01))
diff --git a/tests/data/33fc70f99be6d2833ae48852d611c8048d0c053ed0b2c626db4dbe902832a08b b/tests/data/33fc70f99be6d2833ae48852d611c8048d0c053ed0b2c626db4dbe902832a08b
new file mode 100644
index 000000000..243cd4686
Binary files /dev/null and b/tests/data/33fc70f99be6d2833ae48852d611c8048d0c053ed0b2c626db4dbe902832a08b differ
diff --git a/tests/test-dotnet.c b/tests/test-dotnet.c
index e70dff416..7c0965340 100644
--- a/tests/test-dotnet.c
+++ b/tests/test-dotnet.c
@@ -62,6 +62,16 @@ int main(int argc, char** argv)
       }",
       "tests/data/0ca09bde7602769120fadc4f7a4147347a7a97271370583586c9e587fd396171");
 
+  assert_true_rule_file(
+      "import \"dotnet\" \
+      rule test { \
+        condition: \
+          dotnet.number_of_guids == 2 and \
+          dotnet.guids[0] == \"cb9aa69f-4951-49d2-98a1-18984dcfdb91\" and \
+          dotnet.guids[1] == \"00000000-0000-0000-0000-000000000000\" \
+      }",
+      "tests/data/33fc70f99be6d2833ae48852d611c8048d0c053ed0b2c626db4dbe902832a08b");
+
   yr_finalize();
   return 0;
 }
